<?php
/**
 * Created by JetBrains PhpStorm.
 * User: erikasouza
 * Date: 23/11/12
 * Time: 14:45
 * To change this template use File | Settings | File Templates.
 */

namespace Estoque\Logic\FechamentoDia;

use Setforms2\Runtime\Helper\Procedure\Param;

class ExportaRNF extends \Estoque\Logic\FechamentoDia\ExportAbstract
{


    private $nrorg;
    private $cdFilial;
    private $dtProc;
    private $cdRelatorio;


    public function __construct($param){
        $this->nrorg = $param['NRORG'];
        $this->cdFilial = $param['CDFILIAL'];
        $this->dtProc = $param['DTPROC'];
        $this->cdRelatorio = $param['CDRELATEXP'];
    }


    public function executaProcedure()
    {
        $codigo = $this->cdRelatorio;
        $tamCodigo = strlen($codigo) - 2;
        $param = substr($codigo, $tamCodigo, 2);

        switch ($param){
            case 18:
                $operacao = 'E';        // Entrada
                $identificador = 'E';   // Entrada
                $tipoOper = '_01_03_04_06_08_11_12_16_';
                $formaPgto = '';
                break;
            case 20:
                $operacao = 'S';        // Saída
                $identificador = 'T';   //Transferência
                $tipoOper = '_02_99_';
                $formaPgto = '_V_P_';
                break;
            case 21:
                $operacao = 'S';        //Saída
                $identificador = 'D';   // Devolução
                $tipoOper = '_06_';
                $formaPgto = '_V_P_';
                break;
            case 22:
                $operacao = 'S';        //Saída
                $identificador = 'V';   // Venda a Vista
                $tipoOper = '_01_17_';
                $formaPgto = '_V_';
                break;
            case 23:
                $operacao = 'S';        //Saída
                $identificador = 'P';   // Venda a Prazo
                $tipoOper = '_01_17_';
                $formaPgto = '_P_';
                break;
            case 24:
                $operacao = 'E';        // Entrada
                $identificador = 'C';   // Compra a Vista
                $tipoOper = '_13_';
                $formaPgto = '';
                break;
            case 25:
                $operacao = 'S';        // Saída
                $identificador = 'F';   // Transferencia
                $tipoOper = '_02_99_';
                $formaPgto = '';
                break;
            default:
                return false;
        }

        $params = array(new Param("P_CDFILIAL",
            Param::PARAM_INPUT,
            $this->cdFilial,
            Param::PARAM_TYPE_STR
        ),
            new Param("P_DATA",
                Param::PARAM_INPUT,
                $this->dtProc,
                Param::PARAM_TYPE_STR
            ),
            new Param("P_IDENTRSAIDOP",
                Param::PARAM_INPUT,
                $operacao,
                Param::PARAM_TYPE_STR
            ),
            new Param("P_IDTIPOOPER",
                Param::PARAM_INPUT,
                $identificador,
                Param::PARAM_TYPE_STR
            ),
            new Param("P_CDTIPOOPER",
                Param::PARAM_INPUT,
                $tipoOper,
                Param::PARAM_TYPE_STR
            ),
            new Param("P_IDFORMPGTSAP",
                Param::PARAM_INPUT,
                $formaPgto,
                Param::PARAM_TYPE_STR
            ),
            new Param("P_IDNMARQUIVO",
                Param::PARAM_INPUT,
                substr($param['NMARQTXTEXP'], 1, 1),
                Param::PARAM_TYPE_STR
            ),
        );

        $this->chamaProcedure('EXPORTA_RNF', $params);
        return true;
    }


    public function executaRelatorio()
    {
        // TODO: Implement executaRelatorio() method.
    }


}
