/* Teknisa - Tecnologia em Informtica

 Nome: 0317_CUSFUN_DATAREF_CUSTO_PRODUTO.SQL

 Descrio:
 Funo para retornar a data que o custo foi encontrado.

 Criao:
 20/10/2003 - Alexis Tolentino de Moura
 Converso p/ Sql Server
 06/08/2003 - Daniel Dmaso 
 
 @C:\Win_Prj\Sql\End_Conv\SqlServer\0317_CUSFUN_DATAREF_CUSTO_PRODUTO.SQL
*/
IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'DATAREF_CUSTO_PRODUTO' AND
                 TYPE = 'FN' 		       AND
	              U.UID = O.UID            AND
	              U.NAME = USER)
DROP FUNCTION DATAREF_CUSTO_PRODUTO
GO
                
CREATE FUNCTION DATAREF_CUSTO_PRODUTO(
   @P_CDFILIAL     VARCHAR(4),
   @P_CDPRODUTO    VARCHAR(10),
   @P_NRTIPOCUSTO  NUMERIC,
   @P_DTREFERENCIA DATETIME,
   @P_DTATUAL      DATETIME) RETURNS DATETIME
AS
BEGIN
   DECLARE @V_DTREFERENCIA   DATETIME;
   DECLARE @V_DTREFECUSTO    DATETIME;
   DECLARE @V_IDUTILDTPROC   VARCHAR(1);
   DECLARE @V_CDFILIAL       VARCHAR(4);

   IF @P_NRTIPOCUSTO IN (1,2,3,4,20,21,22,23,24,25,26,27,40,41,42,43,49,50,53,54) BEGIN /*Custos que tem valores na tabela POSESTCONS*/

      IF (@P_NRTIPOCUSTO IN (1,2,20,21,22,23,40,41,49,50,51,52)) BEGIN         /*Custo Mdio Atual*/
         SELECT @V_IDUTILDTPROC = ISNULL(IDUTILDTPROC, 'N')
         FROM PARAMGERAL
         WHERE CDPARGERAL = '0001';
         IF @V_IDUTILDTPROC = 'N' BEGIN
            SET @V_DTREFERENCIA = @P_DTATUAL;
			END
         ELSE BEGIN
            SELECT @V_DTREFERENCIA = ISNULL(DTPROCESSA, @P_DTATUAL)
            FROM PARAMFILIAL P
            WHERE CDFILIAL = @P_CDFILIAL;
         END;
		END
      ELSE BEGIN
         SET @V_DTREFERENCIA = @P_DTREFERENCIA;                 /*Custo Mdio da poca*/
      END;

      SELECT @V_DTREFECUSTO = MAX(DTPOSESTCON)
      FROM POSESTCONS PD
      WHERE CDFILIAL  = @P_CDFILIAL  AND
            CDPRODUTO = @P_CDPRODUTO AND
            DTPOSESTCON <= (@V_DTREFERENCIA+1);

	END
   ELSE BEGIN 
		IF @P_NRTIPOCUSTO IN (6,7,10,30,31,32,33,44,48,45,59,60,61,62) BEGIN /*Custos que tem valores na tabela CUSTOSUP*/
	
   	   IF @P_NRTIPOCUSTO IN (44, 45, 48, 59, 60, 61, 62) BEGIN
      	   SELECT
         	   @V_CDFILIAL = MAX(P.CDFILIOPELOG)
	         FROM
	            PARAMPRODSUP P
	         WHERE
	            P.CDFILIAL  = @P_CDFILIAL AND
	            P.CDPRODUTO = @P_CDPRODUTO;
	         IF @V_CDFILIAL IS NULL BEGIN
	            SET @V_CDFILIAL = @P_CDFILIAL;
	         END;
			END
	      ELSE BEGIN
	         SET @V_CDFILIAL = @P_CDFILIAL;
	      END;
	
	      SELECT @V_DTREFECUSTO = MAX(DTCUSTOSUP)
	      FROM CUSTOSUP
	      WHERE CDFILIAL  = @V_CDFILIAL  AND
	            CDPRODUTO = @P_CDPRODUTO AND
	            VRCUSPRLISTP IS NOT NULL AND
	            DTCUSTOSUP <= @P_DTREFERENCIA;
		END
      ELSE BEGIN
			IF @P_NRTIPOCUSTO IN (8,9,28,29,46,47) BEGIN /*Custos que tem valores na tabela POSESTDIA*/
		      SELECT @V_DTREFECUSTO = MAX(C.DTCUSTCMPPRO)
		      FROM CUSTOCMPPROD C
		      WHERE C.CDFILIAL       = @P_CDFILIAL   AND
		            C.CDPRODUTO      = @P_CDPRODUTO  AND
		            C.DTCUSTCMPPRO  <= @P_DTREFERENCIA;
			END;
		END;

   END;

   RETURN(@V_DTREFECUSTO);
END
GO

-- VERSAO --
EXEC ATUVEROBJ 'DATAREF_CUSTO_PRODUTO','4.11.162';
GO

